<?php

ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources . "includes/connect.php";
require_once $base_path_to_learning_resources . "lib/function.php";
require_once $base_path_to_learning_resources . "lib/validate_api_signature.php";
require_once $base_path_to_learning_resources . "lib/validate_function.php";
require_once $base_path_to_learning . "user_management/authenticate.php";
require_once $base_path_to_learning . 'functions/common_functions.php';
require_once $base_path_to_learning_resources . "includes/specific_db_config.php";
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";
require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';
require_once $base_path_to_learning . "user_management/functions/functions.php";
require_once $base_path_to_learning . "admin_api/modules/library_management/library_function.php";
require_once $base_path_to_learning . "admin_api/modules/transportation/routes/routes_functions.php";

$postdata = json_decode(file_get_contents("php://input"), true);

checkIfNoPhpContentsReceive();

if (
    !isset($postdata['institution_id']) || !checkIfIssetAndNotEmpty($postdata['institution_id']) ||
    !isset($postdata['fuel_expense_id']) || !checkIfIssetAndNotEmpty($postdata['fuel_expense_id']) ||
    !isset($postdata['function_type']) || !checkIfIssetAndNotEmpty($postdata['function_type']) ||
    !isset($postdata['api_signature']) || !checkIfIssetAndNotEmpty($postdata['api_signature']) ||
    !isset($postdata['jwt_token']) || !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);

$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$name = $jwt_validate->data->name;

$institution_id = trim($postdata['institution_id']);
$branch_id = trim($postdata['branch_id']);
$function_type = trim($postdata['function_type']);

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,['superadmin','admin'], $institution_id);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'functions/common_functions.php';
require_once $base_path_to_learning . 'functions/get_branch_functions.php';

$academicSessionId = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
if (!$academicSessionId) {
    errorreturn("Invalid institution_id.");
}

$isBranchClassSubjectValid = checkBranchClassSubject($conn_rjllearning_specific, $branch_id, null, null, $institution_id);
if (!$isBranchClassSubjectValid) {
    errorreturn("Invalid branch_id.");
}

function getSpecificFuelExpenese($conn_rjllearning_specific, $institution_id, $fuel_expense_id) {
    $sql = $conn_rjllearning_specific->prepare("SELECT * FROM fuel_expense WHERE id = ? AND institution_id = ?");
    $sql->execute([$fuel_expense_id, $institution_id]);
    $row = $sql->fetch(PDO::FETCH_ASSOC);
   
    if ($row) {
        $branch_info = getBranchInfo($conn_rjllearning_specific, $institution_id, $row['branch_id']);
        if ($row['bus_id'] === "miscellaneous") {
    
         $bus_number = "miscellaneous";
         } else {
    
          $bus_number_query = "SELECT * FROM buses WHERE id = ?";
          $array_params = [$row['bus_id']];

            $stmt = $conn_rjllearning_specific->prepare($bus_number_query);
            $stmt->execute($array_params);

    // Fetch the result
           $bus_details = $stmt->fetch(PDO::FETCH_ASSOC);
          $bus_number = $bus_details ? $bus_details['bus_number'] : null;
        }

        return [
            'fuel_expense_id' => $row['id'],
            'institution_id' => $row['institution_id'],
            'branch_id' => $branch_info,
            'bus_id' => $row['bus_id'],
            'bus_number' => $bus_number,
            'date' => $row['date'],
            'meter_reading' => $row['meter_reading'],
            'topup' => $row['topup'],
            'narration' => $row['narration'],
            'added_by' => $row['added_by'],
            'date_created' => $row['date_created'],
            'time_created' => $row['time_created']
        ];
    } else {
        errorreturn("Invalid fuel expense info.");
    }
}

if ($postdata['function_type'] == "fetch_specific_fuel_expense") {
    if (!isset($postdata['fuel_expense_id']) || empty(trim($postdata['fuel_expense_id']))) {
        errorreturn("Fuel expense ID is required.");
    }

    $fuel_expense_id = trim($postdata['fuel_expense_id']);

    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if (!$check_academic_confirmation) {
        errorreturn("Access denied. Academic session not active.");
    }

    $fuel_expense_data = getSpecificFuelExpenese($conn_rjllearning_specific, $institution_id, $fuel_expense_id);

    if ($fuel_expense_data) {
        successreturn($fuel_expense_data);
    } else {
        errorreturn("No route available.");
    }
} else {
    errorreturn("Invalid function_type.");
}

?>